Index: ca/rebuild_tree.sh
===================================================================
--- ca/rebuild_tree.sh	(revision 9)
+++ ca/rebuild_tree.sh	(revision 10)
@@ -41,3 +41,4 @@
 make newcert ca=eap.testbed.aaa name=gw.eap.testbed.aaa
 make newcert ca=eap.testbed.aaa name=backend.eap.testbed.aaa
+make newcert ca=eap.testbed.aaa name=supauth2.eap.testbed.aaa
 
Index: conf/backend.eap.testbed.aaa/freeDiameter/freeDiameter.conf
===================================================================
--- conf/backend.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 7)
+++ conf/backend.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 10)
@@ -60,3 +60,4 @@
 
 ConnectPeer = "gw.eap.testbed.aaa" { No_TLS; };
+ConnectPeer = "supauth2.eap.testbed.aaa" { No_TLS; };
 
Index: conf/eapmgr.testbed.aaa/dns/dnsmasq.conf
===================================================================
--- conf/eapmgr.testbed.aaa/dns/dnsmasq.conf	(revision 9)
+++ conf/eapmgr.testbed.aaa/dns/dnsmasq.conf	(revision 10)
@@ -18,4 +18,6 @@
 dhcp-host=08:00:27:D9:B0:9D,opendiam
 dhcp-host=08:00:27:63:F1:B7,supauth2
+dhcp-host=08:00:27:E5:C9:49,radpxy
+dhcp-host=08:00:27:9C:70:CE,supauth3
 
 #conf-dir=/etc/dnsmasq.d
Index: conf/eapmgr.testbed.aaa/dns/hosts
===================================================================
--- conf/eapmgr.testbed.aaa/dns/hosts	(revision 9)
+++ conf/eapmgr.testbed.aaa/dns/hosts	(revision 10)
@@ -15,4 +15,6 @@
 192.168.105.40	opendiam
 192.168.105.50	supauth2
+192.168.105.60	radpxy
+192.168.105.70	supauth3
 fde4:2c6e:55c4:105:a00:27ff:fe33:7782	supauth
 fde4:2c6e:55c4:105:a00:27ff:fef0:a170	gw
Index: conf/gw.eap.testbed.aaa/freeDiameter/freeDiameter.conf
===================================================================
--- conf/gw.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 0)
+++ conf/gw.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 10)
@@ -12,6 +12,6 @@
 
 # "opendiam.eap.testbed.aaa" = { uri="aaa://opendiam.eap.testbed.aaa;transport=sctp"; };
-ConnectPeer = "opendiam.eap.testbed.aaa" {   #TLS_old_Method; 
-						No_TLS; };
+# ConnectPeer = "opendiam.eap.testbed.aaa" {   #TLS_old_Method; 
+#						No_TLS; };
 
 ConnectPeer = "backend.eap.testbed.aaa" { No_TLS; };
Index: conf/gw.eap.testbed.aaa/freeDiameter/rgw.conf
===================================================================
--- conf/gw.eap.testbed.aaa/freeDiameter/rgw.conf	(revision 9)
+++ conf/gw.eap.testbed.aaa/freeDiameter/rgw.conf	(revision 10)
@@ -10,5 +10,5 @@
 
 # Dump state when loop ends
-RGWX = "/root/freeDiameter/extensions/debug.rgwx";
+# RGWX = "/root/freeDiameter/extensions/debug.rgwx";
 
 
Index: conf/radpxy.eap.testbed.aaa/ca_name
===================================================================
--- conf/radpxy.eap.testbed.aaa/ca_name	(revision 10)
+++ conf/radpxy.eap.testbed.aaa/ca_name	(revision 10)
@@ -0,0 +1,1 @@
+eap.testbed.aaa
Index: conf/radpxy.eap.testbed.aaa/ntp.conf
===================================================================
--- conf/radpxy.eap.testbed.aaa/ntp.conf	(revision 10)
+++ conf/radpxy.eap.testbed.aaa/ntp.conf	(revision 10)
@@ -0,0 +1,19 @@
+# /etc/ntp.conf, configuration for ntpd; see ntp.conf(5) for help
+
+driftfile /var/lib/ntp/ntp.drift
+
+statistics loopstats peerstats clockstats
+filegen loopstats file loopstats type day enable
+filegen peerstats file peerstats type day enable
+filegen clockstats file clockstats type day enable
+
+server proxy.testbed.aaa
+
+# By default, exchange time with everybody, but don't allow configuration.
+restrict -4 default kod notrap nomodify nopeer noquery
+restrict -6 default kod notrap nomodify nopeer noquery
+
+# Local users may interrogate the ntp server more closely.
+restrict 127.0.0.1
+restrict ::1
+
Index: conf/supauth2.eap.testbed.aaa/freeDiameter/CMakeFlags
===================================================================
--- conf/supauth2.eap.testbed.aaa/freeDiameter/CMakeFlags	(revision 10)
+++ conf/supauth2.eap.testbed.aaa/freeDiameter/CMakeFlags	(revision 10)
@@ -0,0 +1,9 @@
+-DBUILD_DBG_MONITOR:BOOL=ON 
+-DBUILD_APP_RADGW:BOOL=ON 
+-DBUILD_RGWX_DEBUG:BOOL=ON 
+-DBUILD_RGWX_AUTH:BOOL=ON 
+-DBUILD_RGWX_ACCT:BOOL=ON 
+-DBUILD_RGWX_ECHODROP:BOOL=ON
+-DBUILD_TESTING:BOOL=OFF 
+-DCMAKE_BUILD_TYPE:STRING=DebugValgrind 
+-DDEFAULT_CONF_PATH:PATH=/root/conf/freeDiameter
Index: conf/supauth2.eap.testbed.aaa/freeDiameter/echo_drop.rgwx.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/freeDiameter/echo_drop.rgwx.conf	(revision 10)
+++ conf/supauth2.eap.testbed.aaa/freeDiameter/echo_drop.rgwx.conf	(revision 10)
@@ -0,0 +1,9 @@
+
+# ECHO code 25 ; # Class attributes
+# DROP code 18 ; # Reply-Message attribute, should not be included in requests
+# DROP code 26 vendor 9 ; # Drop any Cisco-specific attribute
+# ECHO code 26 vendor 0 ext 256 ; # Echo any extended attribute with the type 256.
+
+drop code 4 ;
+echo code 33 ;
+
Index: conf/supauth2.eap.testbed.aaa/freeDiameter/freeDiameter.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 10)
+++ conf/supauth2.eap.testbed.aaa/freeDiameter/freeDiameter.conf	(revision 10)
@@ -0,0 +1,18 @@
+SCTP_streams = 3;
+TLS_Cred = "/root/ca_data/cert.pem" , "/root/ca_data/privkey.pem";
+TLS_CA = "/root/ca_data/ca.pem";
+NoRelay;
+
+# LoadExtension = "/root/freeDiameter/extensions/dbg_monitor.fdx";
+
+LoadExtension = "/root/freeDiameter/extensions/dict_nasreq.fdx";
+LoadExtension = "/root/freeDiameter/extensions/dict_eap.fdx";
+LoadExtension = "/root/freeDiameter/extensions/app_radgw.fdx"
+		: "/root/conf/freeDiameter/rgw.conf";
+
+# "opendiam.eap.testbed.aaa" = { uri="aaa://opendiam.eap.testbed.aaa;transport=sctp"; };
+#ConnectPeer = "opendiam.eap.testbed.aaa" {   #TLS_old_Method; 
+#						No_TLS; };
+
+ConnectPeer = "backend.eap.testbed.aaa" { No_TLS; };
+
Index: conf/supauth2.eap.testbed.aaa/freeDiameter/rgw.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/freeDiameter/rgw.conf	(revision 10)
+++ conf/supauth2.eap.testbed.aaa/freeDiameter/rgw.conf	(revision 10)
@@ -0,0 +1,19 @@
+
+# Handle some attributes
+#RGWX = "/root/freeDiameter/extensions/echo_drop.rgwx" : "/root/conf/freeDiameter/echo_drop.rgwx.conf";
+
+# Handle Accounting-Request messages received on the correct port
+RGWX = "/root/freeDiameter/extensions/acct.rgwx" : acct : 4;
+
+# Handle Access-Request messages received on the correct port
+RGWX = "/root/freeDiameter/extensions/auth.rgwx" : auth : 1;
+
+# Dump state when loop ends
+# RGWX = "/root/freeDiameter/extensions/debug.rgwx";
+
+
+##################
+
+nas = 127.0.0.1 / "radiusecret2" ;
+
+
Index: conf/supauth2.eap.testbed.aaa/hostapd/hostapd.conf
===================================================================
--- conf/supauth2.eap.testbed.aaa/hostapd/hostapd.conf	(revision 9)
+++ conf/supauth2.eap.testbed.aaa/hostapd/hostapd.conf	(revision 10)
@@ -23,8 +23,10 @@
 own_ip_addr=192.168.105.50
 nas_identifier=supauth2.eap.testbed.aaa
-auth_server_addr=192.168.105.30
+#auth_server_addr=192.168.105.30
+auth_server_addr=127.0.0.1
 auth_server_port=1812
 auth_server_shared_secret=radiusecret2
-acct_server_addr=192.168.105.30
+#acct_server_addr=192.168.105.30
+acct_server_addr=127.0.0.1
 acct_server_port=1813
 acct_server_shared_secret=radiusecret2
Index: conf/supauth3.eap.testbed.aaa/ca_name
===================================================================
--- conf/supauth3.eap.testbed.aaa/ca_name	(revision 10)
+++ conf/supauth3.eap.testbed.aaa/ca_name	(revision 10)
@@ -0,0 +1,1 @@
+eap.testbed.aaa
Index: conf/supauth3.eap.testbed.aaa/hostapd/build.config
===================================================================
--- conf/supauth3.eap.testbed.aaa/hostapd/build.config	(revision 10)
+++ conf/supauth3.eap.testbed.aaa/hostapd/build.config	(revision 10)
@@ -0,0 +1,8 @@
+# Build-time configuration for hostapd on supauth: authentication role.
+
+# Driver interface for drivers using the nl80211 kernel interface
+CONFIG_DRIVER_NL80211=y
+
+# Build IPv6 support for RADIUS operations
+CONFIG_IPV6=y
+
Index: conf/supauth3.eap.testbed.aaa/hostapd/hostapd.conf
===================================================================
--- conf/supauth3.eap.testbed.aaa/hostapd/hostapd.conf	(revision 10)
+++ conf/supauth3.eap.testbed.aaa/hostapd/hostapd.conf	(revision 10)
@@ -0,0 +1,30 @@
+interface=wlan0
+driver=nl80211
+
+logger_stdout=-1
+logger_stdout_level=2
+dump_file=/tmp/hostapd.dump
+
+ctrl_interface=/var/run/hostapd
+
+hw_mode=g
+channel=1
+ssid=mac80211 test3
+
+wpa=2
+wpa_key_mgmt=WPA-EAP
+wpa_pairwise=CCMP
+
+ieee8021x=1
+eapol_version=2
+eap_message=hello
+
+# Configuration for external RADIUS server, actually a proxy
+own_ip_addr=192.168.105.70
+nas_identifier=supauth3.eap.testbed.aaa
+auth_server_addr=192.168.105.60
+auth_server_port=1812
+auth_server_shared_secret=radiusecret3.1a
+acct_server_addr=192.168.105.60
+acct_server_port=1813
+acct_server_shared_secret=radiusecret3.1b
Index: conf/supauth3.eap.testbed.aaa/ntp.conf
===================================================================
--- conf/supauth3.eap.testbed.aaa/ntp.conf	(revision 10)
+++ conf/supauth3.eap.testbed.aaa/ntp.conf	(revision 10)
@@ -0,0 +1,19 @@
+# /etc/ntp.conf, configuration for ntpd; see ntp.conf(5) for help
+
+driftfile /var/lib/ntp/ntp.drift
+
+statistics loopstats peerstats clockstats
+filegen loopstats file loopstats type day enable
+filegen peerstats file peerstats type day enable
+filegen clockstats file clockstats type day enable
+
+server proxy.testbed.aaa
+
+# By default, exchange time with everybody, but don't allow configuration.
+restrict -4 default kod notrap nomodify nopeer noquery
+restrict -6 default kod notrap nomodify nopeer noquery
+
+# Local users may interrogate the ntp server more closely.
+restrict 127.0.0.1
+restrict ::1
+
Index: conf/supauth3.eap.testbed.aaa/wpasupplicant/build.config
===================================================================
--- conf/supauth3.eap.testbed.aaa/wpasupplicant/build.config	(revision 10)
+++ conf/supauth3.eap.testbed.aaa/wpasupplicant/build.config	(revision 10)
@@ -0,0 +1,26 @@
+# Config file for compilation wpa_supplicant sur supauth.eap.testbed.aaa
+
+# We use the WEXT generic driver with mac80211_hwsim hardware
+CONFIG_DRIVER_WEXT=y
+
+# EAP and EAPoL
+CONFIG_IEEE8021X_EAPOL=y
+CONFIG_EAP_MD5=y
+CONFIG_EAP_MSCHAPV2=y
+CONFIG_EAP_TLS=y
+CONFIG_EAP_PEAP=y
+CONFIG_EAP_TTLS=y
+# CONFIG_EAP_FAST=y
+CONFIG_EAP_GTC=y
+CONFIG_EAP_OTP=y
+CONFIG_EAP_SIM=y
+# ETC...
+CONFIG_EAP_IKEV2=y
+CONFIG_PKCS12=y
+
+CONFIG_EAPOL_TEST=y
+
+CONFIG_CTRL_IFACE=y
+CONFIG_BACKEND=file
+CONFIG_DEBUG_FILE=y
+
Index: conf/supauth3.eap.testbed.aaa/wpasupplicant/wpa_supplicant.conf
===================================================================
--- conf/supauth3.eap.testbed.aaa/wpasupplicant/wpa_supplicant.conf	(revision 10)
+++ conf/supauth3.eap.testbed.aaa/wpasupplicant/wpa_supplicant.conf	(revision 10)
@@ -0,0 +1,18 @@
+ctrl_interface=/var/run/wpa_supplicant
+
+network={
+        ssid="mac80211 test3"
+        key_mgmt=WPA-EAP
+        proto=WPA2
+        pairwise=CCMP
+        group=CCMP
+#	eap=MD5
+#	password="himitsu"
+
+	eap=TLS
+	identity="client2@eap.testbed.aaa"
+	ca_cert="/home/aaa/ca/ca_data/mgr.testbed.aaa/public/cacert.pem"
+	client_cert="/home/aaa/ca/ca_data/mgr.testbed.aaa/clients/client2/cert.pem"
+	private_key="/home/aaa/ca/ca_data/mgr.testbed.aaa/clients/client2/privkey.pem"
+}
+
Index: mrb/update_all_vm.sh
===================================================================
--- mrb/update_all_vm.sh	(revision 0)
+++ mrb/update_all_vm.sh	(revision 10)
@@ -36,6 +36,6 @@
 	# The EAP testbed
 	MGRS="$MGRS eap-eapmgr.testbed.aaa"
-	VMS="$VMS supauth.eap.testbed.aaa gw.eap.testbed.aaa"
-	VMS="$VMS backend.eap.testbed.aaa opendiam.eap.testbed.aaa"
+	VMS="$VMS eap-supauth.eap.testbed.aaa eap-gw.eap.testbed.aaa"
+	VMS="$VMS eap-backend.eap.testbed.aaa"
 	;;
 	
